/* This file is part of cardwords
   (c) 1998 1999 2000 Tobias Peters
   see file COPYING for the copyright terms.
   
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

// cardwords_carddescription.hh

#ifndef CARDWORDS_CARDDESCRIPTION_HH
#define CARDWORDS_CARDDESCRIPTION_HH

#include "cardwords_cardbase.hh"
namespace CardWords {

class CardDescription : public CardBase {
public:
  // the test if this card is a wildcard:
  virtual
  bool
  is_wildcard(void) const;

  // Get the char that is written on this card:
  virtual 
  const Char &
  get_faceValue(void) const;

  // Get the score for this card:
  virtual
  int
  get_points(void) const;

  void set_points(int);

  void
  set_faceValue (Char);

  CardDescription &
  operator = (const CardBase &);

  CardDescription (const CardBase &);
  CardDescription (class istream &);
  CardDescription (Char face,
                             Char means,
                             int score);
  CardDescription ( char face,
                              char means,
                              int score);
  CardDescription ( char faceAndMeans = ' ',
                              int score = 0);
  //       the default constructor creates a blanko

private:
  bool wildcard;
  Char faceValue;
  int  points; // The score for this card.
};
}
class istream & operator >> (class istream &, CardWords::CardDescription &);
#endif
