/* This file is part of cardwords
   (c) 1998 1999 2000 2001 Tobias Peters
   see file COPYING for the copyright terms.
   
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

// cardwords_cardselection.cc

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif
#include <iterator.h>
#include <algo.h>
#include <iostream>
#include "cardwords_cardselection.hh"
#include "cardwords_gettext.hh"
#include "cardwords_exceptions.hh"

istream & operator >>( istream & istream, CardWords::CardSelection & sel)
{
  size_t number = 772227722;
  istream >> number;
  if (istream.bad() || number == 772227722) {
    throw CardWords::XBadInput("CardWords::CardSelection",
			    gettext("number"));
  }
  ;
  sel.clear();

  /* copy_n does not terminate. don't know why. */
  /*
    istream_iterator<CardWords::CardDescription> isiter (istream);
    back_insert_iterator<CardWords::CardSelection> biiter (sel);
    copy_n(isiter, number, biiter);
  */

  // so I use a for-loop:
  CardWords::CardDescription desc;
  for (size_t index = 0; index < number; index++) {
    istream >> desc;
    sel.push_back(desc);
  }
  return istream;
}

ostream & operator <<( ostream & ostream, const CardWords::CardSelection &sel)
{
  ostream << sel.size() << ' ';
  copy (sel.begin(), sel.end(),
	ostream_iterator<CardWords::CardDescription>(ostream," "));
  return ostream;
}

void 
CardWords::CardSelection::clear(void)
{
  erase (begin(),end());
}

CardWords::CardSelection::CardSelection (istream & istream)
{
  istream >> *this;
}

CardWords::CardSelection::CardSelection ()
{}

CardWords::CardSelection &
CardWords::CardSelection::operator += (const CardWords::CardBase & t)
{
  push_back (t);
  return *this;
}

CardWords::CardSelection &
CardWords::CardSelection::operator += (const CardWords::CardSelection & other)
{
  back_insert_iterator<CardWords::CardSelection> dest(*this);

  copy (other.begin(), other.end(), dest);
  return *this;
}

CardWords::CardSelection &
CardWords::CardSelection::operator=(const CardWords::CardBase & t)
{
  clear();
  return (*this) += t;
}
