/* This file is part of cardwords
   (c) 2000 2001 Tobias Peters
   see file COPYING for the copyright terms.
   
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

// cardwords_direction.cc

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif
#include <iostream>
#include "cardwords_direction.hh"
#include "cardwords_exceptions.hh"

CardWords::Direction
operator!(CardWords::Direction d)
{
  return (d == CardWords::horizontal) ?
    CardWords::vertikal : CardWords::horizontal;
}

CardWords::Direction
CardWords::operator!(CardWords::Direction d)
{
  return (d == CardWords::horizontal) ?
    CardWords::vertikal : CardWords::horizontal;
}

ostream &
operator << (ostream & ostream, CardWords::Direction direction)
{
  return ostream << ( (direction == CardWords::horizontal) ?
                      '_'   :   '|'   );
}

istream &
operator >> (istream &istream, CardWords::Direction &direction)
{
  char ch = 0;
  while (istream && (ch == 0 || ch == ' ' || ch == '\n' || ch == '\t')) {
    istream >> ch;
  }

  switch (ch) {
  case '_':
    direction = CardWords::horizontal;
    break;
  case '|':
    direction = CardWords::vertikal;
    break;
  default:
    throw CardWords::XBadInput ("CardWords::Direction",
                               gettext("\'_\' or \'|\'"));
  }
  return istream;
}
