/* This file is part of cardwords
   (c) 1999 2000 Tobias Peters
   see file COPYING for the copyright terms.
   
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

// cardwords_gtk_appearancedialog.hh

#ifndef CARDWORDS_GTK_APPEARANCEDIALOG_HH
#define CARDWORDS_GTK_APPEARANCEDIALOG_HH

#include <gtk--/table.h>
#include <gtk--/adjustment.h>
namespace Gtk {class CheckButton;}
namespace Gtk {class Button;}
namespace Gtk {class SpinButton;}
namespace CardWords {
class Options;

class Gtk_AppearanceDialog : public Gtk::Table
{
public:
  SigC::Signal1<void, const string &> help_signal; // arg is the help_text string
  
  Gtk_AppearanceDialog(Options *);
  ~Gtk_AppearanceDialog();

  // Put the entries' contents into the options object.
  void
  store_options(void);

private:
  // Declaring the copy constructor private. It must not be used.
  Gtk_AppearanceDialog(const Gtk_AppearanceDialog &);

  void
  emit_help_signal(void);

  Gtk::Button * help_button;

  Gtk::CheckButton * digits_for_columns_button;
  Gtk::CheckButton * column_indices_grow_rightwards_button;
  Gtk::CheckButton * row_indices_grow_upwards_button;
  
  Gtk::Label * cell_width_label;
  Gtk::SpinButton * cell_width_entry;
  Gtk::Adjustment cell_width_adjustment;
  
  Gtk::Label * cell_height_label;
  Gtk::SpinButton * cell_height_entry;
  Gtk::Adjustment  cell_height_adjustment;

  Options * options;
};
}
#endif
