/* This file is part of cardwords
   (c) 1999 2000 Tobias Peters
   see file COPYING for the copyright terms.
   
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

// cardwords_gtk_connectdialog.hh

#ifndef CARDWORDS_GTK_CONNECTDIALOG_HH
#define CARDWORDS_GTK_CONNECTDIALOG_HH

#include <gtk--/table.h>
#include <gtk--/adjustment.h>
namespace Gtk {class Entry;}
namespace Gtk {class SpinButton;}
namespace Gtk {class Button;}
namespace CardWords {
class Options;
class Gtk_ConnectDialog : public Gtk::Table
{
public:
  Gtk_ConnectDialog(Options *);
  ~Gtk_ConnectDialog();

  const string &
  get_port_number(void) const;

  SigC::Signal1<void, const string &> help_signal; // arg is the help_text pointer

  // Put the entries' contents into the options object.
  void
  store_options(void);

private:
  // Declaring the copy constructor private. It must not be used.
  Gtk_ConnectDialog(const Gtk_ConnectDialog &);

  void
  emit_help_signal(void);

  Gtk::Label * hostname_label;
  Gtk::Entry * hostname_entry;

  Gtk::Label * port_label;

  Gtk::SpinButton * port_entry;
  Gtk::Adjustment port_adjustment;

  Gtk::Button     * help_button;

  Options * options;
};
}
#endif
