/* This file is part of cardwords
   (c) 1999 2000 Tobias Peters
   see file COPYING for the copyright terms.
   
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

// cardwords_gtk_helpwindow.hh

#ifndef CARDWORDS_GTK_POPUP_HH
#define CARDWORDS_GTK_POPUP_HH

#include <gtk--/window.h>
namespace Gtk {class VBox;}
namespace Gtk {class Text;}
namespace Gtk {class Button;}

// CardWords_Gtk_Popup is a window displaying a popup text and an ok button.

namespace CardWords {

class Gtk_Popup : public Gtk::Window
{
public:  
  Gtk_Popup();
  ~Gtk_Popup();

  void
  show_message(const string & message);

protected:
  virtual gint
  delete_event_impl(GdkEventAny* p1);
  
private:
  // Declaring the copy constructor private. It must not be used.
  Gtk_Popup(const Gtk_Popup & o);

  int
  hide_window(GdkEventAny *);
  
  Gtk::VBox *   vbox;
  Gtk::Text *   text;
  Gtk::Button * button;
};
}
#endif
