/* This file is part of cardwords
   (c) 2000 2001 Tobias Peters
   see file COPYING for the copyright terms.
   
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

// cardwords_hand.cc

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif
#include "cardwords_hand.hh"

CardWords::Hand::Hand(size_t size)
  : CardWords::CardContainer1Dim(size)
{}

CardWords::Card *
CardWords::Hand::draw_card (CardWords::Pile * pile)
{
  if (free_places() == 0) {
    return 0;
  }

  CardWords::Card * card = pile->produce_card();
  if (card != 0) {
    add_card(card);
  }
  return card;
}
