/* This file is part of cardwords
   (c) 2000 2001 Tobias Peters
   
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

// cardwords_move.cc

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif
#include "cardwords_move.hh"
#include "cardwords_cardtablelocation.hh"

CardWords::Move::Move()
  : direction(horizontal)
{}

CardWords::Move &
CardWords::Move::operator=(const CardWords::CardDescription & desc)
{
  this->CardWords::CardSelection::operator=(desc);
  return *this;
}

CardWords::Move &
CardWords::Move::operator=(const CardWords::CardSelection & sel)
{
  this->CardWords::CardSelection::operator=(sel);
  return *this;
}

CardWords::Move &
CardWords::Move::operator=(const CardWords::Move & other)
{
  *this = static_cast<const CardWords::CardSelection &> (other);
  location = other.location;
  direction = other.direction;
  return *this;
}

CardWords::Move::Move(const CardWords::CardSelection & sel)
  : CardWords::CardSelection(sel),
    direction(horizontal)
{}


ostream &
operator << (ostream & ostream, const CardWords::Move & move)
{
  return ostream << move.location << ' '
                 << move.direction << ' '
                 << static_cast<const CardWords::CardSelection &>(move);
}

istream &
operator >> (istream & istream, CardWords::Move & move)
{
  return istream >> move.location
                 >> move.direction
                 >> static_cast<CardWords::CardSelection &>(move);
}
