/* This file is part of cardwords
   (c) 1999 2000 Tobias Peters
   see file COPYING for the copyright terms.
   
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
//cardwords_serversocket.hh

#ifndef CARDWORDS_SERVERSOCKET_HH
#define CARDWORDS_SERVERSOCKET_HH

#define CARDWORDS_SERVER_BACKLOG 2

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>

#include <fcntl.h>
#include "cardwords_server.hh"
#include "cardwords_select.hh"
#include <vector>
#include "cardwords_exceptions.hh"
namespace CardWords {

class ServerSocket : public Selectible {
public:
  ServerSocket(Selector *,
                         unsigned short int port_no = PORT_NUMBER);

  virtual
  void
  being_selected(int fd, int mode);

  virtual
  void
  timed_out(int, int){assert (0);};

private:
  Selector * selector;
  
  int fd;

  int port_no;
  
  unsigned short int get_port_no(void) const;
  
  struct sockaddr_in sock_addr;
};
}
#endif
